// $Id$
//
//  image.m
//  PDFlib
//
//

#import "image.h"

#if TARGET_OS_IPHONE
#import "PDFlib_ios/PDFlib_objc.h"
#else
#import "PDFlib/PDFlib_objc.h"
#endif

@implementation image


+ (NSData *) run {
    NSInteger image;
    NSData *pdfdata = nil;
    NSString *imagefile = [[NSBundle mainBundle] pathForResource:@"nesrin" ofType:@"jpg"];

      
    PDFlib *pdflib = [[PDFlib alloc] init];
    if (!pdflib) {
        return nil;
    }
    
    @try { 
        [pdflib set_option:@"errorpolicy=exception"];
        
        [pdflib begin_document:@"" optlist:@""];        
        [pdflib set_info:@"Creator" value:@"image_ios"];
        [pdflib set_info:@"Author" value:@"Thomas Merz"];
        [pdflib set_info:@"Title" value:@"image sample (Objective-C)"];
        
        image = [pdflib load_image:@"auto" filename:imagefile  optlist:@""];
                
        /* dummy page size, will be adjusted by PDF_fit_image() */        
        [pdflib begin_page_ext:10 height:10 optlist:@""];
        [pdflib fit_image: image x:0 y:0 optlist: @"adjustpage"];      
        [pdflib close_image:image];
        [pdflib end_page_ext:@""];
        [pdflib end_document:@""];
        
        pdfdata = [pdflib get_buffer];
    }        
    @catch (PDFlibException *ex) { 
        NSString * errorMessage = 
	    [NSString stringWithFormat:@"PDFlib error %ld in '%@': %@",
            (long)[ex get_errnum], [ex get_apiname], [ex get_errmsg]];
#if TARGET_OS_IPHONE
        UIAlertView *alert = [[UIAlertView alloc] 
            initWithTitle:[ex name] message:errorMessage
            delegate:self cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
#else
        NSAlert *alert = [[NSAlert alloc] init];
        [alert setMessageText: errorMessage];
        [alert runModal];
#endif
    }
    @catch (NSException *ex) { 
#if TARGET_OS_IPHONE
        UIAlertView *alert = [[UIAlertView alloc] 
            initWithTitle:[ex name] message:[ex reason]
            delegate:self cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
#else
        NSAlert *alert = [[NSAlert alloc] init];
        [alert setMessageText: [ex reason]];
        [alert runModal];
#endif
    } 

    return pdfdata;
}

@end
